#include <QApplication>
#include <QWebEngineUrlSchemeHandler>
#include <QWebEngineUrlRequestJob>
#include <QWebEngineProfile>
#include <QWebEngineView>
#include <QBuffer>
#include <QFile>

class MyHandler : public QWebEngineUrlSchemeHandler
{
public:
    MyHandler(QObject *parent = nullptr) {}
    void requestStarted(QWebEngineUrlRequestJob *request)
    {
        QUrl url = request->requestUrl();
        QFile f("example.html");
        f.open(QIODevice::ReadOnly);
        
        QBuffer *buf = new QBuffer(this);
        buf->setData(f.readAll());
        
        request->reply("text/html", buf);
    }
};

int main(int argc, char **argv)
{
    QApplication app(argc, argv);

    QWebEngineProfile::defaultProfile()->installUrlSchemeHandler("conapp", new MyHandler);
    QWebEngineView view;
    view.load(QUrl("conapp://test"));
    view.show();
    return app.exec();
}
